import numpy as np


pi = np.float64(np.pi)

# Fundamental constants
c = np.float64(299792458)  # m/s
G = np.float64(6.67408e-11)  # m^3/kg/s^2
h = np.float64(6.626070040e-34)  # kg m^2 / s
e = np.float64(1.6021766208e-19)  # C
m_e = np.float64(9.10938356e-31)  # kg
k_B = np.float64(1.38064852e-23)  # kg m / K / s^2 = J / K
amu = np.float64(1.66053904e-27)  # kg
mu_0 = 4 * pi * 10 ** (-7)  # kg m / C^2
hbar = h / (2 * pi)
epsilon_0 = 1 / (mu_0 * c ** 2)
mu_B = e * hbar / (2 * m_e)
N_A = np.float64(6.022140857e23)  # Avogadro constant
FINE_STRUCTURE_CONSTANT = mu_0 * e ** 2 * c / (2 * h)
BOHR_RADIUS = hbar / (m_e * c * FINE_STRUCTURE_CONSTANT)  # meters


# conversion factors
mEV_TO_EV = np.float64(1 / 1000)
EV_TO_mEV = 1 / mEV_TO_EV
BOHR_TO_M = BOHR_RADIUS
BOHR_TO_METERS = BOHR_RADIUS
BOHR_TO_ANGSTROM = BOHR_TO_M * 10 ** 10
M_TO_BOHR = 1 / BOHR_TO_M
JOULES_TO_EV = 1 / e
JOULES_TO_mEV = JOULES_TO_EV * 1000
JOULES_TO_RYDBERG = 2 / (FINE_STRUCTURE_CONSTANT ** 2 * m_e * c ** 2)
CM_TO_EV = 100 * h * c * JOULES_TO_EV
CM_TO_mEV = CM_TO_EV * 1000
CM_TO_THZ = 1e-10 * c
RYDBERG_TO_JOULES = 1 / JOULES_TO_RYDBERG
RYDBERG_TO_EV = RYDBERG_TO_JOULES * JOULES_TO_EV
RYDBERG_TO_mEV = RYDBERG_TO_EV * 1000
EV_TO_CM = 1 / CM_TO_EV
EV_TO_JOULES = 1 / JOULES_TO_EV
EV_TO_RYDBERG = 1 / RYDBERG_TO_EV
EV_TO_THZ = EV_TO_CM * CM_TO_THZ
HARTREE_TO_JOULES = 2 * RYDBERG_TO_JOULES
HARTREE_TO_EV = HARTREE_TO_JOULES * JOULES_TO_EV
HARTREE_TO_mEV = HARTREE_TO_EV * EV_TO_mEV
HARTREE_TO_CM = HARTREE_TO_EV * EV_TO_CM
HA_TO_CM = HARTREE_TO_CM
EV_TO_HARTREE = 1 / HARTREE_TO_EV
ANGSTROM_TO_BOHR = 1 / BOHR_TO_ANGSTROM
ANGSTROM_TO_M = 10 ** (-10)
ANGSTROM_TO_CM = 100 * ANGSTROM_TO_M
THZ_TO_CM = 1 / CM_TO_THZ
KELVIN_TO_JOULES = k_B
KELVIN_TO_EV = KELVIN_TO_JOULES * JOULES_TO_EV
KELVIN_TO_RYDBERG = KELVIN_TO_EV * EV_TO_RYDBERG
KELVIN_TO_mEV = KELVIN_TO_EV * 1000
KELVIN_TO_HARTREE = KELVIN_TO_EV * EV_TO_HARTREE
KELVIN_TO_CELSIUS = np.float64(-273.15)  # additive constant
CELSIUS_TO_KELVIN = -KELVIN_TO_CELSIUS  # additive constant
mEV_TO_CM = 1 / CM_TO_mEV
mEV_TO_KELVIN = 1 / KELVIN_TO_mEV
mEV_TO_RYDBERG = 1 / RYDBERG_TO_mEV
mEV_TO_THZ = mEV_TO_CM * CM_TO_THZ
EV_TO_KELVIN = 1 / KELVIN_TO_EV

AMU_TO_ME = amu / m_e
AMU_TO_KG = amu

M_TO_CM = 100

# Pressures
GPA_TO_EV_per_BOHR3 = JOULES_TO_EV / (M_TO_BOHR ** 3) * 10 ** 9

# aliases
HA_TO_EV = HARTREE_TO_EV
HARTREE_TO_KELVIN = HARTREE_TO_JOULES / k_B
ANGSTROM_TO_METERS = ANGSTROM_TO_M
